<?php

namespace HAI\Includes;

use HAI\Includes\HAI_Connect_helios;

class HAI_Admin {

    public function __construct() {

        if ( ! is_admin() ) return;

        add_action('admin_menu', [$this, 'hai_admin_menu']);

        $this->menu_slug = 'hai_admin_menu';
    }

    public function hai_admin_menu() {
        $capability = 'manage_options';
        $menu_slug  = $this->menu_slug;
        $function   = 'hai_menu_page';
        $icon_url   = 'dashicons-index-card';
        $position   = 4;
        add_menu_page(
            'Helios AI',
            'Helios AI',
            $capability,
            $menu_slug,
            '',
            $icon_url,
            $position
        );
        add_submenu_page($menu_slug, 'Helios AI dashboard', 'Helios AI dashboard', 'manage_options', $menu_slug, [$this, $function . '_settings'], 1);
        // add_submenu_page( $menu_slug, 'Helios AI beállítások', 'Helios AI beállítások', 'manage_options', $menu_slug . '_db_settings', [ $this, $function . '_db_settings' ], 1 );
    }

    public function form_actions(){
        if ( ! current_user_can( 'manage_options' ) ) {
            return;
          }
        if(!isset($_POST['type'])) return;
        $type = $_POST['type'];
        $success = true;
        $message = "";
        switch ($type) {
            case 'newsletter_group':
                if(isset($_POST['newsletter_is_on']) && $_POST['newsletter_is_on'] == "on"){
                    update_option('hai_newsletter_is_on', 1);
                }else{
                    update_option('hai_newsletter_is_on', 0);
                }
                if(isset($_POST['newsletter_default_true']) && $_POST['newsletter_default_true'] == "on"){
                    update_option('hai_newsletter_default_true', 1);
                }else{
                    update_option('hai_newsletter_default_true', 0);
                }
                
                if(isset($_POST['newsletter_email_field_first']) && $_POST['newsletter_email_field_first'] == "on"){
                    update_option('hai_newsletter_email_field_first', 1);
                }else{
                    update_option('hai_newsletter_email_field_first', 0);
                }
                update_option('hai_newsletter_default_group', $_POST['newsletter_default_group']);
                update_option('hai_newsletter_checkbox_text', $_POST['newsletter_checkbox_text']);
                break;
            
            default:
                # code...
                break;
        }
        if($success){
            ?>
<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible">
    <p><strong>Beállítások elmentve. <?=$message?></strong></p><button type="button" class="notice-dismiss"><span
            class="screen-reader-text">Értesítés elvetése.</span></button>
</div>
<?php
}else{
    ?>
<div id="setting-error-settings_updated" class="notice notice-error settings-error is-dismissible">
    <p><strong>Beállítások elmentése sikertelen. <?=$message?></strong></p><button type="button"
        class="notice-dismiss"><span class="screen-reader-text">Értesítés elvetése.</span></button>
</div>
<?php
}
?>
<script>
jQuery('.notice-dismiss').click(function() {
    jQuery(this).parents('notice').hide();
});
</script>
<?php
    }

    public function hai_menu_page_settings() {
        if ( ! current_user_can( 'manage_options' ) ) {
            return;
          }
        $this->form_actions();
          //Get the active tab from the $_GET param
        $default_tab = null;
        $default_tab = 'newsletter';
        $tab = isset($_GET['tab']) ? $_GET['tab'] : $default_tab;
        ?>
<div class="wrap">
    <h1 class="wp-heading-inline">Helios AI dashboard</h1>
    <nav class="nav-tab-wrapper">
        <!--<a href="?page=<?=$this->menu_slug?>"
            class="nav-tab <?php if($tab===null):?>nav-tab-active<?php endif; ?>">Általános</a>
        <a href="?page=<?=$this->menu_slug?>&tab=settings"
            class="nav-tab <?php if($tab==='settings'):?>nav-tab-active<?php endif; ?>">Beállítások</a>
        <a href="?page=<?=$this->menu_slug?>&tab=tools"
            class="nav-tab <?php if($tab==='tools'):?>nav-tab-active<?php endif; ?>">Eszközök</a>-->
        <a href="?page=<?=$this->menu_slug?>&tab=newsletter"
            class="nav-tab <?php if($tab==='newsletter'):?>nav-tab-active<?php endif; ?>">Hírlevél</a>
    </nav>
    <div class="tab-content" style="padding: 16px;">
        <?php
        ob_start();

        switch($tab){
            case 'settings':
              echo 'Beállítások'; //Put your HTML here
              break;
            case 'tools':
              echo 'Eszközök';
              break;
            case 'newsletter':
                require HAI_PLUGIN_PATH . 'templates/admin/main/hai-admin-newsletter.php';
              break;
            default:
              require HAI_PLUGIN_PATH . 'templates/admin/main/hai-admin-dashboard.php';
              break;
            }
        

        echo ob_get_clean();
        echo '</div></div>';
    }

}