<?php

namespace HAI\Includes;

class HAI_Dbs
{

    public function __construct() {

        global $wpdb;

        $this->wpdb = $wpdb;

        $this->hai_funnels();
        $this->hai_funnel_views();
        $this->hai_funnel_clicks();
        $this->hai_product_page_visit_log();
        $this->hai_abandoned_carts();

    }

    private function hai_funnels() {

        $table_name = $this->wpdb->prefix . "hai_funnels";
        $hai_funnels_db_version = '1.0.0';
        $charset_collate = $this->wpdb->get_charset_collate();

        if ($this->wpdb->get_var("SHOW TABLES LIKE '{$table_name}'") != $table_name) {

            $sql = "CREATE TABLE $table_name (
                funnel_id INT(25),
                card_id INT(25),
                products TEXT,
                trigger_product_ids TEXT,
                active BOOLEAN,
                config TEXT
            ) $charset_collate;";

            require_once ABSPATH . 'wp-admin/includes/upgrade.php';
            dbDelta($sql);
            add_option('hai_funnels_db_version', $hai_funnels_db_version);
        }
    }

    private function hai_funnel_views() {

        $table_name = $this->wpdb->prefix . "hai_funnel_views";
        $hai_funnel_views_db_version = '1.0.0';
        $charset_collate = $this->wpdb->get_charset_collate();

        if ($this->wpdb->get_var("SHOW TABLES LIKE '{$table_name}'") != $table_name) {

            $sql = "CREATE TABLE $table_name (
                funnel_id INT(25),
                card_id INT(25),
                trigger_id INT(25),
                timestamp INT(25)
            ) $charset_collate;";

            require_once ABSPATH . 'wp-admin/includes/upgrade.php';
            dbDelta($sql);
            add_option('hai_funnel_views_db_version', $hai_funnel_views_db_version);
        }
    }

    private function hai_funnel_clicks() {

        $table_name = $this->wpdb->prefix . "hai_funnel_clicks";
        $hai_funnel_clicks_db_version = '1.0.0';
        $charset_collate = $this->wpdb->get_charset_collate();

        if ($this->wpdb->get_var("SHOW TABLES LIKE '{$table_name}'") != $table_name) {

            $sql = "CREATE TABLE $table_name (
                funnel_id INT(25),
                card_id INT(25),
                trigger_id INT(25),
                product_id INT(25),
                timestamp INT(25)
            ) $charset_collate;";

            require_once ABSPATH . 'wp-admin/includes/upgrade.php';
            dbDelta($sql);
            add_option('hai_funnel_clicks_db_version', $hai_funnel_clicks_db_version);
        }
    }

    private function hai_product_page_visit_log() {

        $table_name = $this->wpdb->prefix . "hai_product_page_visit_log";
        $hai_product_page_visit_log_db_version = '1.0.0';
        $charset_collate = $this->wpdb->get_charset_collate();

        if ($this->wpdb->get_var("SHOW TABLES LIKE '{$table_name}'") != $table_name) {

            $sql = "CREATE TABLE $table_name (
                product_id INT(25),
                timestamp INT(25)
            ) $charset_collate;";

            require_once ABSPATH . 'wp-admin/includes/upgrade.php';
            dbDelta($sql);
            add_option('hai_product_page_visit_log_db_version', $hai_product_page_visit_log_db_version);
        }
    }

    private function hai_abandoned_carts() {

        $table_name = $this->wpdb->prefix . "hai_abandoned_carts";
        $hai_abandoned_carts_db_version = '1.0.0';
        $charset_collate = $this->wpdb->get_charset_collate();

        if ($this->wpdb->get_var("SHOW TABLES LIKE '{$table_name}'") != $table_name) {

            $sql = "CREATE TABLE $table_name (
                `hash` VARCHAR(32),
                content TEXT,
                created DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP
            ) $charset_collate;";

            require_once ABSPATH . 'wp-admin/includes/upgrade.php';
            dbDelta($sql);
            add_option('hai_abandoned_carts_db_version', $hai_abandoned_carts_db_version);
        }
    }

}