<?php

namespace HAI\Includes;

class HAI_Setters {

    public function __construct() {

        global $wpdb;
        $this->wpdb = $wpdb;

        // $this->HAI_CATEGORY_ORDER = $this->wpdb->prefix . "hai_category_order";
        // $this->HAI_PRODUCT_ORDER = $this->wpdb->prefix . "hai_product_order";
        $this->hai_funnels = $this->wpdb->prefix . "hai_funnels";
        $this->hai_funnel_views = $this->wpdb->prefix . "hai_funnel_views";
        $this->hai_funnel_clicks = $this->wpdb->prefix . "hai_funnel_clicks";
        $this->hai_abandoned_carts = $this->wpdb->prefix . "hai_abandoned_carts";

    }

    // inserters

    public function insert_hai_category_order($datas)
    {
        $this->wpdb->insert(
            $this->HAI_CATEGORY_ORDER,
            $datas,
        );
    }

    public function insert_hai_product_order($datas)
    {
        $this->wpdb->insert(
            $this->HAI_PRODUCT_ORDER,
            $datas,
        );
    }

    // updaters

    public function update_hai_category_order($datas, $id)
    {
        $this->wpdb->update(
            $this->HAI_CATEGORY_ORDER,
            $datas,
            array('id' => $id),
        );
    }

    public function update_hai_product_order($datas, $id)
    {
        $this->wpdb->update(
            $this->HAI_PRODUCT_ORDER,
            $datas,
            array('id' => $id),
        );
    }

    // setters

    /**
     * to do @Geri
     */

    // deleters

    public function delete_hai_category_order($id)
    {
        $this->wpdb->delete(
            $this->HAI_CATEGORY_ORDER,
            array('id' => $id),
        );
    }

    public function delete_hai_product_order($id)
    {
        $this->wpdb->delete(
            $this->HAI_PRODUCT_ORDER,
            array('id' => $id),
        );
    }

    //  truncate

    public function truncate_hai_category_order()
    {
        $this->wpdb->query("TRUNCATE TABLE {$this->HAI_CATEGORY_ORDER}");
    }

    public function truncate_hai_product_order()
    {
        $this->wpdb->query("TRUNCATE TABLE {$this->HAI_PRODUCT_ORDER}");
    }

    public function order( $datas ) {

        if ( ! isset( $datas['id'] ) ) return 'Missing id!';

        $id = $datas['id'];

        $order = new \WC_Order( $id ) ;

        if ( isset( $datas['status'] ) ) $order->update_status( $datas['status'] );
        if ( isset( $datas['customer_note'] ) ) $order->set_customer_note( $datas['customer_note'] );
        if ( isset( $datas['billing'] ) ) $order->set_address( $datas['billing'], 'billing' );
        if ( isset( $datas['shipping'] ) ) $order->set_address( $datas['shipping'], 'shipping' );

        $order->save();

        return $id;

    }

    public function order_status( $id, $status ) {

        $order = new \WC_Order( $id ) ;
        $order->update_status( $status );

        return $id;

    }

    public function product( $datas ) {

        if ( isset( $datas['id'] ) ) {

            return $this->update_product( $datas );

        } else {

            $id = $this->create_product( $datas );
                                
            wp_update_post( array(
                'ID' => $id,
                'post_status' => 'publish'
            ));

            return $id;

        }

    }

    private function create_product( $datas ) {

        if ( ! isset( $datas['type'] ) ) return 'Missing product type!';
        if ( ! isset( $datas['title'] ) && $datas['type'] != 'variation' ) return 'Missing title!';
        if ( ! isset( $datas['sku'] ) ) return 'Missing sku!';

        global $wpdb;

        $sql = 'SELECT post_id FROM ' . $wpdb -> prefix . 'postmeta WHERE meta_key = "_sku" AND meta_value = "' . $datas['sku'] . '"';                                        
        $result = $wpdb -> get_results( $sql );
                            
        if ( empty( $result ) ) {

            switch ( $datas['type'] ) {

                case 'simple':
                    
                    $id = wp_insert_post( array( 'post_title' => $datas['title'], 'post_type' => 'product' ) );
                    break;

                case 'variable':

                    $product = new \WC_Product_Variable();
                    $product->set_name( $datas['title'] );
                    $product->save();
                    $id = $product->get_id();

                    break;

                case 'variation':

                    if ( ! isset( $datas['parent_id'] ) ) return 'Missing parent_id!';
    
                    $product = wc_get_product( $datas['parent_id'] );
                
                    $variation_post = array(
                        'post_title'  => $product->get_name(),
                        'post_name'   => 'product-'.$product->get_id().'-variation',
                        'post_status' => 'publish',
                        'post_parent' => $product->get_id(),
                        'post_type'   => 'product_variation',
                        'guid'        => $product->get_permalink()
                    );
                
                    $id = wp_insert_post( $variation_post );
                    
                    break;
                
                default:
                    return 'Wrong product type!';

            }
            
            update_post_meta( $id, '_sku', $datas['sku'] );

            update_post_meta( $id, '_manage_stock', 'yes' );

            $datas['id'] = $id;

            unset( $datas['title'] );

            return $this->update_product( $datas );
            
        } else {

            return 'This SKU is already in use for another product!';
            
            // $datas['id'] = $result[ 0 ] -> post_id;
            
            // return $this->update_product( $datas );
            
        }

    }

    private function update_product( $datas ) {

        $id = $datas['id'];

        if ( isset( $datas['type'] ) && $datas['type'] == 'variation' ) {
            $product = new \WC_Product_Variation( $id );
        } else {
            $product = wc_get_product( $id );
        }
        if ( ! $product ) return 'Wrong id!';
        // if ( isset( $datas['regular_price'] ) ) $product->set_regular_price( $datas['regular_price'] );
        if ( isset( $datas['price'] ) ) {
            $product->set_regular_price( $datas['price'] );
            $product->set_price( $datas['price'] );
        }
        if ( isset( $datas['sale_price'] ) ) {
            if ( $datas['sale_price'] == 0 ) {
                $product->set_sale_price( '' );
                update_post_meta( $id, '_sale_price_dates_from', '' );
                update_post_meta( $id, '_sale_price_dates_to', '' );
            } else {
                if ( isset( $datas['sale_price_dates_from'] ) || isset( $datas['sale_price_dates_to'] ) ) {
                    _wc_save_product_price(
                        $id,
                        $product->get_regular_price(),
                        $datas['sale_price'],
                        ( ( isset( $datas['sale_price_dates_from'] ) ) ? $datas['sale_price_dates_from'] : null ),
                        ( ( isset( $datas['sale_price_dates_to'] ) ) ? $datas['sale_price_dates_to'] : null ),
                    );
                } else $product->set_sale_price( $datas['sale_price'] );
            }
        }
        if ( isset( $datas['stock'] ) ) {
            wc_update_product_stock( $product, $datas['stock'], 'set', 'false' );
            ( $datas['stock'] > 0 ) ? wc_update_product_stock_status( $id, 'instock' ) : wc_update_product_stock_status( $id, 'outofstock' );
        }
        if ( isset( $datas['categories'] ) && is_array( $datas['categories'] ) ) {
            wp_set_object_terms($id, $datas['categories'], 'product_cat');
        }
        if ( isset( $datas['tags'] ) && is_array( $datas['tags'] ) ) {
            wp_set_object_terms($id, $datas['tags'], 'product_tag');
        }
        if ( isset( $datas['attributes'] ) && is_array( $datas['attributes'] ) ) {
            foreach ( $datas['attributes'] as $attribute ) {
                $get_attribute = wc_get_attribute( $attribute['id'] );
                $is_variation = ( isset( $attribute['is_variation'] ) ) ? $attribute['is_variation'] : 0;
                $product_attributes[$get_attribute->slug] = array(
                    'name' => $get_attribute->slug,
                    'value' => $attribute['values'],
                    'is_visible' => '1',
                    'is_variation' => $is_variation,
                    'is_taxonomy' => '1'
                );
                if ( isset( $datas['type'] ) && $datas['type'] == 'variation' ) {

                    $term_slug = get_term_by('name', $attribute['values'][0], $get_attribute->slug )->slug;
            
                    update_post_meta( $id, 'attribute_'.$get_attribute->slug, $term_slug );

                } else {
                    $term_taxonomy_ids = wp_set_object_terms( $id, $attribute['values'], $get_attribute->slug, false );
                }
            }
            update_post_meta( $id, '_product_attributes', $product_attributes );
        }
        if ( isset( $datas['title'] ) ) $product->set_name( $datas['title'] );
        if ( isset( $datas['description'] ) ) $product->set_description( $datas['description'] );
        if ( isset( $datas['short_description'] ) ) $product->set_short_description( $datas['short_description'] );
        if ( isset( $datas['cross_sell_ids'] ) && is_array( $datas['cross_sell_ids'] ) ) $product->set_cross_sell_ids( $datas['cross_sell_ids'] );
        if ( isset( $datas['upsell_ids'] ) && is_array( $datas['upsell_ids'] ) ) $product->set_upsell_ids( $datas['upsell_ids'] );
        if ( isset( $datas['related_product_ids'] ) && is_array( $datas['related_product_ids'] ) ) update_post_meta( $id, 'related_product_ids', $datas['related_product_ids'] );
        if ( isset( $datas['length'] ) ) $product->set_length( $datas['length'] );
        if ( isset( $datas['width'] ) ) $product->set_width( $datas['width'] );
        if ( isset( $datas['height'] ) ) $product->set_height( $datas['height'] );
        if ( isset( $datas['weight'] ) ) $product->set_weight( $datas['weight'] );
        if ( isset( $datas['status'] ) ) {
            wp_update_post( array(
                'ID' => $id,
                'post_status' => $datas['status']
            ));
        }
        if ( isset( $datas['images'] ) && is_array( $datas['images'] ) ) {
            require_once( ABSPATH . 'wp-admin/includes/media.php' );
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
            require_once( ABSPATH . 'wp-admin/includes/image.php' );
            $featured_image_url = $datas['images'][0];
            unset( $datas['images'][0] );
            if ( ! has_post_thumbnail( $id ) ) {
                $attached_id = $this->is_attached( $featured_image_url );
                if ( ! $attached_id ) $attached_id = media_sideload_image( $featured_image_url, $id, '', 'id' );
                set_post_thumbnail( $id, $attached_id );
            }
            if ( count( $datas['images'] ) > 0 ) {
                $attached_ids = explode( ',', get_post_meta( $id, '_product_image_gallery', true ) );
                if ( ! count( $attached_ids ) > 0 ) $attached_ids = [];
                foreach ( $datas['images'] as $img_url ) {
                    $attached_id = $this->is_attached( $img_url );
                    if ( ! $attached_id ) $attached_id = media_sideload_image( $img_url, $id, '', 'id' );
                    $attached_ids[] = $attached_id;
                }
                update_post_meta( $id, '_product_image_gallery', implode( ',', array_unique($attached_ids) ) );
            }
        }

        $product->save();

        return $id;

    }

    public function create_tag( $tag, $description = '' ) {
        
        $term = wp_insert_term(
            $tag,
            'product_tag',
            array(
                'description' => $description,
            )
        );

        return intval($term['term_id']);

    }

    public function create_attribute( $attribute ) {

        $args      = array(
            'name'         => $attribute['name'],
            'type'         => 'select',
            'order_by'     => 'menu_order',
            'has_archives' => 0,
        );

        if ( isset( $attribute['slug'] ) ) $args['slug'] = $attribute['slug'];
        if ( isset( $attribute['has_archives'] ) ) $args['has_archives'] = $attribute['has_archives'];
        
        $attribute_id = wc_create_attribute( $args );

        return $attribute_id;

    }

    public function update_attribute( $attribute ) {

        $get_attribute = wc_get_attribute( $attribute['id'] );

        $attribute_arr = [];

        if ( isset( $attribute['name'] ) ) $attribute_arr['name'] = $attribute['name'];
        if ( isset( $attribute['slug'] ) ) $attribute_arr['slug'] = $attribute['slug'];
        if ( isset( $attribute['has_archives'] ) ) $attribute_arr['has_archives'] = $attribute['has_archives'];

        if ( count( $attribute_arr ) > 0 ) wc_update_attribute( $attribute['id'], $attribute_arr );

        if ( isset( $attribute['values'] ) && is_array( $attribute['values'] ) ) {
            foreach ( $attribute['values'] as $value ) {
                wp_insert_term( $value, $get_attribute->slug );
            }

        }

        return $attribute['id'];

    }

    public function update_tag( $tag ) {

        $tag_arr = [];

        if ( isset( $tag['name'] ) ) $tag_arr['name'] = $tag['name'];
        if ( isset( $tag['slug'] ) ) $tag_arr['slug'] = $tag['slug'];
        if ( isset( $tag['description'] ) ) $tag_arr['description'] = $tag['description'];
        
        wp_update_term( $tag['id'], 'product_tag', $tag_arr );

        return $tag['id'];

    }

    public function create_category( $category ) {

        $term = wp_insert_term(
            $category['name'],
            'product_cat',
        );

        if ( is_wp_error( $term ) ) {
            $error_code = array_key_first( $term->errors );
            return $term->errors[$error_code][0];
        }

        $category['id'] = intval($term['term_id']);
        unset( $category['name'] );

        $id = $this->update_category( $category );
        
        return $id;

    }

    public function update_category( $category ) {

        $cat = [];

        if ( isset( $category['name'] ) ) $cat['name'] = $category['name'];
        if ( isset( $category['slug'] ) ) $cat['slug'] = $category['slug'];
        if ( isset( $category['description'] ) ) $cat['description'] = $category['description'];
        if ( isset( $category['parent'] ) ) $cat['parent'] = $category['parent'];
        if ( isset( $category['image'] ) ) {

            require_once( ABSPATH . 'wp-admin/includes/media.php' );
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
            require_once( ABSPATH . 'wp-admin/includes/image.php' );
        
            $attached_id = $this->is_attached( $category['image'] );
            if ( ! $attached_id ) $attached_id = media_sideload_image( $category['image'], $category['id'], '', 'id' );
            update_term_meta( $category['id'], 'thumbnail_id', $attached_id );

        }
        
        wp_update_term( $category['id'], 'product_cat', $cat );

        return $category['id'];

    }

    public function orders( $orders ) {

        $ids = [];

        foreach ( $orders as $order ) {

            if ( isset( $order['id'] ) ) {
    
                $ids[] = $this->order( $order );
    
            } else  {
    
                // $ids[] = $this->create_order( $order );
    
            }
            
        }

        return $ids;

    }

    public function attributes( $attributes ) {

        $ids = [];

        foreach ( $attributes as $attribute ) {

            if ( isset( $attribute['id'] ) ) {
    
                $ids[] = $this->update_attribute( $attribute );
    
            } else  {
    
                $ids[] = $this->create_attribute( $attribute );
    
            }
            
        }

        return $ids;

    }

    public function tags( $tags ) {

        $ids = [];

        foreach ( $tags as $tag ) {

            if ( isset( $tag['id'] ) ) {
    
                $ids[] = $this->update_tag( $tag );
    
            } else  {
    
                $ids[] = $this->create_tag( $tag['name'], ( isset( $tag['description'] ) ) ? $tag['description'] : '' );
    
            }
            
        }

        return $ids;

    }

    public function categories( $categories ) {

        $ids = [];

        foreach ( $categories as $category ) {

            if ( isset( $category['id'] ) ) {
    
                $ids[] = $this->update_category( $category );
    
            } else  {
    
                $ids[] = $this->create_category( $category );
    
            }
            
        }

        // return json_encode($categories);

        return $ids;

    }

    public function products( $products ) {

        $ids = [];

        foreach ( $products as $product ) {
            $ids[] = $this->product( $product );
        }

        return $ids;

    }

    public function funnels( $funnels ) {

        $f = [];

        foreach ( $funnels as $funnel ) {
            $f[] = $this->funnel( $funnel );
        }

        return $f;

    }

    public function funnel( $funnel ) {

        $funnel_id = $funnel['funnel_id'];
        $card_id = $funnel['card_id'];
        
        $row = $this->wpdb->get_results("SELECT * FROM {$this->hai_funnels} WHERE funnel_id={$funnel_id} AND card_id={$card_id}");
        // return $card_id;

        if ( $row ) {

            unset($funnel['funnel_id']);
            unset($funnel['card_id']);

            $update = $this->wpdb->update( 
                $this->hai_funnels,
                $funnel, 
                array(
                    'funnel_id' => $funnel_id,
                    'card_id' => $card_id,
                )
            );
    
            if( $update === false ){
                return false;
            }
    
            return true;

        }
    
        $insert = $this->wpdb->insert( $this->hai_funnels, $funnel );
    
        if( $insert === false ){
            return false;
        }

        return true;

    }

    /**
     * Added by: Bence
     */

    public function funnel_view($funnel){
        if(isset($funnel['funnel_id']) && 
        isset($funnel['card_id']) && 
        isset($funnel['trigger_id']) && 
        isset($funnel['timestamp'])){

            $this->wpdb->insert($this->hai_funnel_views, $funnel);
            return true;
        }
    return false;
    }

    public function funnel_click($funnel){
        if(isset($funnel['funnel_id']) && 
        isset($funnel['card_id']) && 
        isset($funnel['trigger_id']) && 
        isset($funnel['product_id']) && 
        isset($funnel['timestamp'])){

            // Mivel ez frontendről lesz, nehogy beküldjenek valami mást:
            $funnel = [
                'funnel_id' => $funnel['funnel_id'],
                'card_id' => $funnel['card_id'],
                'trigger_id' => $funnel['trigger_id'],
                'product_id' => $funnel['product_id'],
                'timestamp' => $funnel['timestamp']
            ];
                
            $this->wpdb->insert($this->hai_funnel_clicks, $funnel);
            return true;
        }
        return false;
    }

    public function create_abandoned_cart($cart_items, $hash){
        if(isset($cart_items) && isset($hash)){
            $data = ['hash' => $hash, 'content' => serialize( $cart_items )];

            $this->wpdb->insert($this->hai_abandoned_carts, $data);
        }
        return false;
    }

     /**
      * End of Added by: Bence
      */

    private function is_attached( $img_url ) {

        $filename = basename($img_url);

        global $wpdb;
        
        $wp_postmeta = $wpdb->prefix.'postmeta';
        $results = $wpdb->get_col( "SELECT post_id FROM $wp_postmeta WHERE meta_value LIKE '%$filename%'" );

        if ( count( $results ) > 0 ) return array_unique($results)[0];

        return false;

    }

}