<?php

namespace HAI\Includes;

use HAI\Includes\HAI_Connect_helios;

class HAI_Submits {

    public function __construct() {

        // add_action( 'admin_post_cp_search_autocomplete', [ $this,'cp_search_autocomplete' ] );
        add_action( 'wp_ajax_hai_add_to_cart', [ $this, 'hai_add_to_cart' ] );
        add_action( 'wp_ajax_nopriv_hai_add_to_cart', [ $this, 'hai_add_to_cart' ] );
        add_action( 'wp_ajax_hai_funnel_click', [ $this, 'hai_funnel_click' ] );
        add_action( 'wp_ajax_nopriv_hai_funnel_click', [ $this, 'hai_funnel_click' ] );
        add_action( 'wp_ajax_hai_abandoned_cart', [ $this, 'hai_abandoned_cart' ] );
        add_action( 'wp_ajax_nopriv_hai_abandoned_cart', [ $this, 'hai_abandoned_cart' ] );
        //add_action( 'wp_ajax_hai_elementor_newsletter_groups', [ $this, 'hai_elementor_newsletter_groups' ] );
        

    }

    public function hai_add_to_cart() {
        global $hai_funnel;
        remove_action( 'woocommerce_add_to_cart', [$hai_funnel, 'funnel_popup'], 10 );

        // var_dump($_POST);
        $prods = json_decode( str_replace( '\\', '', $_POST["checkedProds"] ), true );
        //var_dump( $prods );
        foreach ( $prods as $prod ) {
            $funnel = (new HAI_Getters() )->get_funnel($_POST['funnel_id'], $_POST['card_id'])[0];
            $products = json_decode(str_replace( '\\', '', $funnel->products ));
            foreach($products as $p){
                if($p->id == $prod["prodId"]){
                    $prod_2 = wc_get_product($prod["prodId"]);
                    $prod_price = $prod_2->get_price();
                    if($prod['variation'] != 0){
                        $prod['variation'] = $this->find_matching_product_variation_id($prod["prodId"], $prod['attributes']);
                        $add_to_cart_attributes = [];
                        foreach($prod['attributes'] as $key => $a){
                            $add_to_cart_attributes[$key] = $a['name'];
                        }
                        $var_prods = $prod_2->get_available_variations();
                        foreach ($var_prods as $variation){
                            if($variation['variation_id'] == $prod['variation']){
                                $prod_price = $variation['display_price'];
                                break;
                            }
                        }
                    }
                    switch ($p->discount_type) {
                        case '1':
                            $price = $prod_price - ( $prod_price * $p->discount_value / 100 );
                            break;
                        
                        case '2':
                            $price = $prod_price - $p->discount_value;
                            break;
                        
                        default:
                            $price = $prod_price;
                            break;
                    break;
                    }
                }
            }
            WC()->cart->add_to_cart( 
                $prod["prodId"],
                1,
                $prod['variation'],
                $add_to_cart_attributes,
                array( 
                    'hai_price' => $price,
                    'hai_sold_by_helios' => 1,
                    'hai_funnel_id' => $_POST['funnel_id'],
                    'hai_card_id' => $_POST['card_id']
                ) 
            );
        }
        add_action( 'woocommerce_add_to_cart', [$hai_funnel, 'funnel_popup'], 10 );
        wp_send_json_success( "OK" );
        //wp_die();
    }

    private function find_matching_product_variation_id($product_id, $attributes) {
        $product = wc_get_product($product_id);
        $variations = $product->get_available_variations();
        foreach ($variations as $variation) {
            $match = true;
            foreach ($attributes as $name => $a) {
                if ($variation['attributes'][$name] !== urlencode($a['slug']) && $variation['attributes'][urlencode($name)] !== '') {
                    $match = false;
                    break;
                }
            }
            if ($match) {
                return $variation['variation_id'];
            }
        }
        return null; // No matching variation found
    }
    
    public function hai_funnel_click(){
        $funnel = json_decode(str_replace( '\\', '', $_POST["funnel"] ), true);
        $funnel['timestamp'] = time();
        ( new HAI_Setters() )->funnel_click($funnel);
        
        wp_send_json_success( "OK" );
        //wp_die();
    }

    public function hai_abandoned_cart(){
        // if email isn't valid
        $email = $_POST['billing_email'];
        if(filter_var($email, FILTER_VALIDATE_EMAIL) === false){
            wp_send_json_error( 'Helytelen email cím.' );
            die;
        }

        /*
        Cart example:
        $cart = [
            [
                'id' => 123,
                'quantity' => 12,
                'price' => 1200,
                'image' => "URL"
            ], ...
        ];
        */

        // Initialize the cart array
        $cart = [];

        // Get the WooCommerce cart items
        $cart_items = WC()->cart->get_cart();
        $cart_hash = WC()->cart->get_cart_hash();

        // Loop through each cart item and add to the custom cart array
        foreach ( $cart_items as $cart_item_key => $cart_item ) {

            $product = wc_get_product( $cart_item['product_id'] );
            $thumbnail_url = wp_get_attachment_url( $product->get_image_id() );
            $product_name = $product->get_name();

            $cart[] = [
                'id' => $cart_item['product_id'],
                'quantity' => $cart_item['quantity'],
                'price' => wc_price( $cart_item['data']->get_price() ),
                'image' => $thumbnail_url,
                'name' => $product_name
            ];
        }

        $postfields = [
            'apikey' => get_option( 'hai_api_token' ),
            'cart' => json_encode($cart),
            'email' => $email,
            'hash' => $cart_hash
        ];

        $res = ( new HAI_Connect_helios('abandonedCart') )->connect($postfields);

        (new HAI_Setters())->create_abandoned_cart($cart_items, $cart_hash);

        wp_send_json_success( $res );
    }

    /*public function hai_elementor_newsletter_groups(){
        $postfields = [];
        $postfields['apikey'] = get_option( 'hai_api_token' );
        $res = ( new HAI_Connect_helios('getNewsletterLists') )->connect($postfields);
        wp_send_json( $res, 200 );
    }*/

}