<?php

class HAI_Taxonomys
{

    public function __construct()
    {
        add_action('init', array($this, 'create_brand_taxonomy'));
    }

    public function create_brand_taxonomy()
    {
        $labels = array(
            'name' => _x('Brands', 'taxonomy general name', 'woocommerce'),
            'singular_name' => _x('Brand', 'taxonomy singular name', 'woocommerce'),
            'search_items' => __('Search Brands', 'woocommerce'),
            'all_items' => __('All Brands', 'woocommerce'),
            'parent_item' => __('Parent Brand', 'woocommerce'),
            'parent_item_colon' => __('Parent Brand:', 'woocommerce'),
            'edit_item' => __('Edit Brand', 'woocommerce'),
            'update_item' => __('Update Brand', 'woocommerce'),
            'add_new_item' => __('Add New Brand', 'woocommerce'),
            'new_item_name' => __('New Brand Name', 'woocommerce'),
            'menu_name' => __('Brand', 'woocommerce'),
        );

        $args = array(
            'hierarchical' => false,
            'labels' => $labels,
            'show_ui' => true,
            'show_admin_column' => true,
            'query_var' => true,
            'rewrite' => array('slug' => 'brand'),
        );

        register_taxonomy('product_brand', array('product'), $args);
    }

}