<?php

namespace HAI\Modules;

use HAI\Includes\HAI_Getters;

class HAI_Funnels {

    public function __construct() {

        // if ( ! is_admin() ) return;

        add_action( 'woocommerce_before_add_to_cart_form', [$this, 'funnel_embed'] );
        add_action( 'woocommerce_add_to_cart', [$this, 'funnel_popup'], 1, 2 );
        add_filter('woocommerce_add_to_cart_fragments', [$this, 'funnel_popup_fragment']);
        add_action( 'wp_footer', [$this, 'show_popup'], 1 );

        add_action( 'wp', [ $this, 'product_page_visit_log' ] );

    }

    public function funnel_embed() {

        global $product;

        $id = $product->get_id();

        $funnels = ( new HAI_Getters() )->get_triggered_funnels( $id );

        if ( count( $funnels ) < 1 ) return;

        ob_start();
        require HAI_PLUGIN_PATH . 'templates/hai-funnel-embed.php';
        echo ob_get_clean();

    }

    static public function funnel_popup( $cart_id, $id ) {

        $product = wc_get_product( $id );

        $funnels = ( new HAI_Getters() )->get_triggered_funnels( $id );

        if ( count( $funnels ) < 1 ) return;
        $funnel = $funnels[0];
        $config = json_decode( $funnel->config );
        if($config->display_type == 1){
            ob_start();
            echo '<script src="https://code.jquery.com/jquery-3.7.1.min.js" integrity="sha256-/JqT3SQfawRcv/BIHPThkBvs0OEvtFFmqPF/lYI/Cxo=" crossorigin="anonymous"></script>';
            echo '<input type="hidden" name="hai_funnel_id" value="'.$funnel->funnel_id.'">';
            echo '<input type="hidden" name="hai_card_id" value="'.$funnel->card_id.'">';
            require HAI_PLUGIN_PATH . 'templates/hai-checkout-popup.php';
            global $HAI_POPUP;
            global $HAI_POPUP_SCRIPT;
            $HAI_POPUP = ob_get_clean();
            $HAI_POPUP_SCRIPT = $popup_script;
            WC()->session->set( 'hai_popup', $HAI_POPUP );
            WC()->session->set( 'hai_popup_script', $HAI_POPUP_SCRIPT );
        }

    }

    static public function funnel_popup_fragment ( $fragments ) {

        global $HAI_POPUP;
        global $HAI_POPUP_SCRIPT;
        $HAI_POPUP = WC()->session->get( 'hai_popup' );
        $HAI_POPUP_SCRIPT = WC()->session->get( 'hai_popup_script' );
        if($HAI_POPUP){
            $fragments['hai_popup'] = $HAI_POPUP;
            $fragments['hai_popup_script'] = $HAI_POPUP_SCRIPT;
        }
            // Clear the session data to prevent repeated popups
        WC()->session->__unset( 'hai_popup' );
        WC()->session->__unset( 'hai_popup_script' );
        return $fragments;
    }

    public function show_popup(){
        global $HAI_POPUP;
        global $HAI_POPUP_SCRIPT;
        if(isset($HAI_POPUP)){
            echo $HAI_POPUP;
            echo "<script>";
            echo $HAI_POPUP_SCRIPT;
            echo "</script>";
        }
    }

    public function product_page_visit_log() {

        if (is_product()) {

            global $wpdb;

            $table_name = $wpdb->prefix . "hai_product_page_visit_log";

            $wpdb->insert( 
                $table_name, 
                array( 
                    'product_id' => get_the_ID(),
                    'timestamp' => time(),
                ) 
            );

        }

    }

}